#include	<stdio.h>
#include	<rwlib.h>

char searchstr[] = "\n#include";
char fname[256];

main (int argc,char **argv)
{
	FILE *f;
	int i;
	if (argc == 1)
		perr ("cdep v1.0 by Russell Wallace  " __DATE__ "\n"
				"Generates dependency reports for C source files\n"
				"Usage: cdep <source files>");
	for (i=1 ; i<argc ; i++)
	{
		f = Fopen (argv[i],"r");
		int doneinputfname = FALSE;
		int j,c;
		j = 1;
		while ((c = fgetc (f)) != EOF)
			if (c == searchstr[j])
			{
				j++;
				if (!searchstr[j])
				{
					do
						c = fgetc (f);
					while (c != EOF && c != '"' && c != '\n');
					if (c != EOF)
					{
						if (c == '\n')
							j = 1;
						else
						{
							j = 0;
							do
								fname[j++] = c = fgetc (f);
							while (c != EOF && c != '"');
							fname[j-1] = 0;
							if (!doneinputfname)
							{
								printf ("%s:",argv[i]);
								doneinputfname = TRUE;
							}
							printf (" %s",fname);
							if (c == EOF)
								break;
							j = 0;
						}
					}
					else
						break;
				}
			}
			else
				j = 0;
		if (doneinputfname)
			putchar ('\n');
		fclose (f);
	}
	return 0;
}
